\ This is your Forth library file.  This file provides you with
\ access to the kernel extension(s) you have installed.  Be sure that
\ you have downloaded the install.txt file prior to this.  You only
\ have to download install.txt once.  Even a factory cleanup won't
\ erase it.  This file defines in the Forth dictionary all the
\ symbols used.  It also provides a generic memory map.  Feel free
\ to change it if necessary, and be carefull if you change the pointers
\ in code that is downloaded after this file.

hex                             \ Set the base to hex
which.map 0=        \ Only if in standard map, copy flash contents to ram
 iftrue 4 page.to.ram   \ and switch maps
        5 page.to.ram   \
        6 page.to.ram  download.map
 endiftrue

0000 4 dp x!        \ Start definitions at page 4
4000 6 np x!        \ and start names half way up page 6

anew kxlibrary
15 width !
\ ----Beginning of package memory allocation listing----
\ Package PCCard_MIB_Driver_v6.2 Code: 070000 - 0753f2 Vars: 008e00 - 008e47
\ Package To_xFlash_v1.4         Code: 0753f4 - 075e45 Vars: 008e48 - 008e48
\ ----End of package memory allocation listing----
\
\ ----Beginning of memory usage diagram----
\ ** Vars usage each block is 0x100 bytes.  X=Used x=partially used .=not used
\ Vars 00: Range: 008e00 - 00ae00 Used:0048 [x...............................]
\ Vars 01: Range: 00b000 - 00b3ef Used:0000 [....]
\
\ ** Code usage each block is 0x400 bytes.  X=Used x=partially used .=not used
\ Code 00: Range: 070000 - 077fff Used:5e45 [XXXXXXXXXXXXXXXXXXXXXXXx........]
\ Code 01: Range: 0d0000 - 0d7fff Used:0000 [................................]
\ Code 02: Range: 5f0000 - 5f7fff Used:0000 [................................]
\ Code 03: Range: 5e0000 - 5e7fff Used:0000 [................................]
\ Code 04: Range: 5d0000 - 5d7fff Used:0000 [................................]
\ Code 05: Range: 5c0000 - 5c7fff Used:0000 [................................]
\ Code 06: Range: 5b0000 - 5b7fff Used:0000 [................................]
\ Code 07: Range: 5a0000 - 5a7fff Used:0000 [................................]
\ Code 08: Range: 590000 - 597fff Used:0000 [................................]
\ Code 09: Range: 580000 - 587fff Used:0000 [................................]
\ Code 10: Range: 570000 - 577fff Used:0000 [................................]
\ Code 11: Range: 560000 - 567fff Used:0000 [................................]
\ Code 12: Range: 550000 - 557fff Used:0000 [................................]
\ Code 13: Range: 540000 - 547fff Used:0000 [................................]
\ Code 14: Range: 530000 - 537fff Used:0000 [................................]
\ Code 15: Range: 520000 - 527fff Used:0000 [................................]
\ Code 16: Range: 510000 - 517fff Used:0000 [................................]
\ Code 17: Range: 500000 - 507fff Used:0000 [................................]
\ ----End of memory usage diagram----

\ The Kernel Extensions used 0x0047 actual bytes of variable space
base @ hex din 008e48 vp x! base !

base @ hex
\ Variables for Kernel Extension Package: PCCard_MIB_Driver
vp x@
vp x!
\ Symbols for Kernel Extension Package: PCCard_MIB_Driver
dp x@
din 07081f dp x! create ATA_COMMAND
din 070364 dp x! create ATA_FAIL
din 07097e dp x! create ATA_ID_DRIVE
din 070971 dp x! create ATA_READ
din 070a14 dp x! create ATA_SET_FEATURES
din 070964 dp x! create ATA_WRITE
din 070382 dp x! create CARD_SIZE
din 071241 dp x! create CLEAR_FILE_ERROR
din 072aed dp x! create DIR
din 072af4 dp x! create DIR_NAMES
din 072afb dp x! create DIR_OPEN
din 0753b8 dp x! create DO_AUTOEXEC
din 074b43 dp x! create END_UPDATE
din 07003d dp x! create FI
din 075073 dp x! create FILE_ABORT_ACTION
din 074f53 dp x! create FILE_ASK_KEY
din 074acd dp x! create FILE_CAPTURE
din 073837 dp x! create FILE_CLOSE
din 071125 dp x! create FILE_CONTENTS
din 07429d dp x! create FILE_COPY
din 074f8d dp x! create FILE_EMIT
din 071261 dp x! create FILE_EOF
din 071257 dp x! create FILE_ERROR
din 073547 dp x! create FILE_FLUSH
din 0748da dp x! create FILE_GETC
din 07492d dp x! create FILE_GETS
din 074efd dp x! create FILE_INTERPRETER
din 074f31 dp x! create FILE_KEY
din 073876 dp x! create FILE_OPEN
din 074905 dp x! create FILE_PUTC
din 0749c4 dp x! create FILE_PUTS
din 074aaa dp x! create FILE_PUT_CRLF
din 073d33 dp x! create FILE_READ
din 074150 dp x! create FILE_REMOVE
din 0741f1 dp x! create FILE_RENAME
din 073726 dp x! create FILE_REWIND
din 073655 dp x! create FILE_SEEK
din 07371f dp x! create FILE_SET_POS
din 0711d5 dp x! create FILE_SIZE
din 073736 dp x! create FILE_TELL_POS
din 072749 dp x! create FILE_TIME
din 0744e1 dp x! create FILE_TO_MEMORY
din 074645 dp x! create FILE_TO_PAGE
din 0743eb dp x! create FILE_TYPE
din 074a2c dp x! create FILE_UNGETC
din 073a0e dp x! create FILE_WRITE
din 07036e dp x! create HIDDEN_SECTORS
din 070f00 dp x! create INIT_FILE_HEAP
din 075327 dp x! create INIT_FILE_IO
din 0753a5 dp x! create INIT_FILE_SYSTEM
din 07112f dp x! create MAX_FILE_SIZE
din 070378 dp x! create NUMSECTORS_TRANSFERRED
din 0747aa dp x! create PAGE_TO_FILE
din 070259 dp x! create PCC_PRESENT
din 0752ca dp x! create PROCESS_AUTOEXEC
din 0752bd dp x! create PROCESS_FILE
din 074faf dp x! create PUT_DEFAULT_SERIAL
din 070036 dp x! create READ_CF_MODULE
din 0750b9 dp x! create REDIRECT
din 071490 dp x! create REPORT_FILE_ERRORS
din 0712be dp x! create REPORT_FILE_OPEN_ERRORS
din 07002f dp x! create SET_CF_MODULE
din 073020 dp x! create SET_FILESIZE
din 0711e2 dp x! create VOLUME_LABEL
dp x!
base !

\ Beginning raw forthfile for package: PCCard_MIB_Driver
DECIMAL

512 CONSTANT SECTOR_SIZE \ default Block{sector} size of flash card or ATA drive
HEX

\ Result Failure Flags (may be OR'd together; values assigned by Mosaic)
100 CONSTANT FAIL_ID_DRIVE \ failed ATA_ID_DRIVE/bad master boot rec;also used in FAT code
80 CONSTANT FAIL_BUSY      \ Drive Was Busy (timed out)
40 CONSTANT FAIL_READY     \ Drive Not Ready (Drive Ready Bit)
20 CONSTANT FAIL_DATAREQ   \ synchronize error: DRQ wasn't as expected during xfer
10 CONSTANT FAIL_EXT_ERR   \ Extended Error Code Command Failed
08 CONSTANT FAIL_CMD       \ Command Failed to Complete
04 CONSTANT FAIL_ADDR      \ sector Number out of range
02 CONSTANT FAIL_NO_CARD   \ No Card Present
01 CONSTANT FAIL_ARGS      \ Arguments to call were invalid

HEX

\ Result Failure Flags (may be OR'd together)
01  CONSTANT ERR_ATA_READ   \ see +results for details
02  CONSTANT ERR_ATA_WRITE  \ see +results for details
04  CONSTANT ERR_NOT_DOSFAT_DRIVE   \ disk is not dos/fat-formatted
08  CONSTANT ERR_INVALID_SECTOR_NUMBER  \ usually because of bad ata_read into buf
10  CONSTANT ERR_CANNOT_ADD_CLUSTER   \ no available clusters; disk full?
20  CONSTANT ERR_NEGATIVE_FILE_POSN   \ file_posn <0
40  CONSTANT ERR_WRITE_ACCESS_VIOLATION \ file isn't writeable
80  CONSTANT ERR_READ_ACCESS_VIOLATION  \ file isn't readable
100 CONSTANT ERR_FAIL_ID_DRIVE \ Couldn't execute ATA_ID_DRIVE;
                \ number matches fail_id_drive defined in driver
\ the following are saved in +file_open_error; set in file_open, check_fileid
200  CONSTANT ERR_CANNOT_TRUNCATE_FILE
400  CONSTANT ERR_FILE_DOES_NOT_EXIST
800  CONSTANT ERR_ROOT_DIR_FULL
1000 CONSTANT ERR_DISK_IS_FULL
2000 CONSTANT ERR_TOO_MANY_FILES_OPEN
4000 CONSTANT ERR_BAD_OR_UNOPEN_FILEID  \ out of range fileid
\ final standard error flag, saved in ata_file struct:
8000 CONSTANT ERR_EOF       \ file_posn > filesize: end of file reached.

\ file pointer modes for file_seek and its callers:
1 CONSTANT FROM_START
2 CONSTANT FROM_END
3 CONSTANT FROM_CURRENT


\ file access privileges (C-style); see table 11-2 in Darnell C book.
01 CONSTANT FILE_MUST_EXIST   \ r and r+ modes: file must exist before open
02 CONSTANT OLD_FILE_TRUNCATED  \ w and w+ modes: truncate to 0 upon open
04 CONSTANT READABLE_STREAM   \ r, r+, w+, a+ modes
08 CONSTANT WRITEABLE_STREAM    \ w, a, r+, w+, a+ modes
10 CONSTANT WRITEABLE_AT_END_ONLY \ a, a+ modes; writes start at prior eof.


FILE_MUST_EXIST READABLE_STREAM OR CONSTANT             R_MODE
OLD_FILE_TRUNCATED WRITEABLE_STREAM OR CONSTANT           W_MODE
WRITEABLE_STREAM WRITEABLE_AT_END_ONLY OR CONSTANT          A_MODE
FILE_MUST_EXIST READABLE_STREAM OR WRITEABLE_STREAM OR CONSTANT   RPLUS_MODE
OLD_FILE_TRUNCATED READABLE_STREAM OR WRITEABLE_STREAM OR CONSTANT  WPLUS_MODE
READABLE_STREAM WRITEABLE_STREAM OR WRITEABLE_AT_END_ONLY OR CONSTANT APLUS_MODE


-2 CONSTANT NO_ECHO_FILEID
  \ passed as output_fileid to process_file to revector emit as drop.

\ AXE FILE_MUST_EXIST     \ axe unneeded headers
\ AXE OLD_FILE_TRUNCATED
\ AXE READABLE_STREAM
\ AXE WRITEABLE_STREAM
\ AXE WRITEABLE_AT_END_ONLY


\ End of raw forthfile for package: PCCard_MIB_Driver
base @ hex
\ Variables for Kernel Extension Package: To_xFlash
vp x@
vp x!
\ Symbols for Kernel Extension Package: To_xFlash
dp x@
din 075df9 dp x! create DOWNLOAD_MAP_QVGA
din 075e0c dp x! create DOWNLOAD_MAP_WCB
din 075c64 dp x! create IS_XFLASH
din 075c3b dp x! create IS_XRAM
din 075c90 dp x! create PAGE_TO_XFLASH
din 075ae4 dp x! create QUERY_XMEMORY
din 075e1f dp x! create STANDARD_MAP_QVGA
din 075e32 dp x! create STANDARD_MAP_WCB
din 0758ec dp x! create TO_XFLASH
dp x!
base !

\ Beginning raw forthfile for package: To_xFlash

\ End of raw forthfile for package: To_xFlash
\ End of Forth library file
\ Save RAM pages to flash and preserve pointers.  to restore after cold,
\ download.map 1 page.to.ram 2 page.to.ram 3 page.to.ram restore
4 page.to.flash
5 page.to.flash
6 page.to.flash
save
