// This is the C header file.  It contains the prototypes and constants that
// are used in the runtime routines.  The ifndef/define lines below provide an
// interlock so that the contents of this file will be parsed exactly once
// even if it is #included in more than one place within the same source file.

// How to use this file:  Be sure to #include it before library.c.  See the
// example source files.  Only #include library.c once, but #include this file
// in any other source files that contain calls to kernel extensions.

// the following are useful to transform a 32-bit xaddr into separate 16-bit addr, page
#ifndef XADDR_TO_ADDR
#define XADDR_TO_ADDR(xaddress)    ((uint) (0xFFFF & (xaddress)))
#define XADDR_TO_PAGE(xaddress)    ((int) (0xFF & ((xaddress)>>16)))

#endif  //   XADDR_TO_ADDR

#ifndef __KERNEL_EXTENSION_HEADER_FILE__  // The #endif will be in the postamble file
#define __KERNEL_EXTENSION_HEADER_FILE__

// ----Beginning of package memory allocation listing----
// Package PCCard_MIB_Driver_v6.2 Code: 070000 - 0753f2 Vars: 008e00 - 008e47
// Package To_xFlash_v1.4         Code: 0753f4 - 075e45 Vars: 008e48 - 008e48
// ----End of package memory allocation listing----
#pragma option nowarn=dup
#asm
.VarStart:  equ  $8e48
#endasm
#pragma option warn=dup
// Variables for Kernel Extension Package: To_xFlash
// Symbols for Kernel Extension Package: To_xFlash
#define                                      DOWNLOAD_MAP_QVGA_XADDR   0x075df9
#define                                       DOWNLOAD_MAP_QVGA_PAGE   0x0007
#define                                       DOWNLOAD_MAP_QVGA_ADDR   0x5df9
#define                                       DOWNLOAD_MAP_WCB_XADDR   0x075e0c
#define                                        DOWNLOAD_MAP_WCB_PAGE   0x0007
#define                                        DOWNLOAD_MAP_WCB_ADDR   0x5e0c
#define                                              IS_XFLASH_XADDR   0x075c64
#define                                               IS_XFLASH_PAGE   0x0007
#define                                               IS_XFLASH_ADDR   0x5c64
#define                                                IS_XRAM_XADDR   0x075c3b
#define                                                 IS_XRAM_PAGE   0x0007
#define                                                 IS_XRAM_ADDR   0x5c3b
#define                                         PAGE_TO_XFLASH_XADDR   0x075c90
#define                                          PAGE_TO_XFLASH_PAGE   0x0007
#define                                          PAGE_TO_XFLASH_ADDR   0x5c90
#define                                          QUERY_XMEMORY_XADDR   0x075ae4
#define                                           QUERY_XMEMORY_PAGE   0x0007
#define                                           QUERY_XMEMORY_ADDR   0x5ae4
#define                                      STANDARD_MAP_QVGA_XADDR   0x075e1f
#define                                       STANDARD_MAP_QVGA_PAGE   0x0007
#define                                       STANDARD_MAP_QVGA_ADDR   0x5e1f
#define                                       STANDARD_MAP_WCB_XADDR   0x075e32
#define                                        STANDARD_MAP_WCB_PAGE   0x0007
#define                                        STANDARD_MAP_WCB_ADDR   0x5e32
#define                                              TO_XFLASH_XADDR   0x0758ec
#define                                               TO_XFLASH_PAGE   0x0007
#define                                               TO_XFLASH_ADDR   0x58ec
// Variables for Kernel Extension Package: PCCard_MIB_Driver
// Symbols for Kernel Extension Package: PCCard_MIB_Driver
#define                                            ATA_COMMAND_XADDR   0x07081f
#define                                             ATA_COMMAND_PAGE   0x0007
#define                                             ATA_COMMAND_ADDR   0x081f
#define                                               ATA_FAIL_XADDR   0x070364
#define                                                ATA_FAIL_PAGE   0x0007
#define                                                ATA_FAIL_ADDR   0x0364
#define                                           ATA_ID_DRIVE_XADDR   0x07097e
#define                                            ATA_ID_DRIVE_PAGE   0x0007
#define                                            ATA_ID_DRIVE_ADDR   0x097e
#define                                               ATA_READ_XADDR   0x070971
#define                                                ATA_READ_PAGE   0x0007
#define                                                ATA_READ_ADDR   0x0971
#define                                       ATA_SET_FEATURES_XADDR   0x070a14
#define                                        ATA_SET_FEATURES_PAGE   0x0007
#define                                        ATA_SET_FEATURES_ADDR   0x0a14
#define                                              ATA_WRITE_XADDR   0x070964
#define                                               ATA_WRITE_PAGE   0x0007
#define                                               ATA_WRITE_ADDR   0x0964
#define                                              CARD_SIZE_XADDR   0x070382
#define                                               CARD_SIZE_PAGE   0x0007
#define                                               CARD_SIZE_ADDR   0x0382
#define                                       CLEAR_FILE_ERROR_XADDR   0x071241
#define                                        CLEAR_FILE_ERROR_PAGE   0x0007
#define                                        CLEAR_FILE_ERROR_ADDR   0x1241
#define                                                    DIR_XADDR   0x072aed
#define                                                     DIR_PAGE   0x0007
#define                                                     DIR_ADDR   0x2aed
#define                                              DIR_NAMES_XADDR   0x072af4
#define                                               DIR_NAMES_PAGE   0x0007
#define                                               DIR_NAMES_ADDR   0x2af4
#define                                               DIR_OPEN_XADDR   0x072afb
#define                                                DIR_OPEN_PAGE   0x0007
#define                                                DIR_OPEN_ADDR   0x2afb
#define                                            DO_AUTOEXEC_XADDR   0x0753b8
#define                                             DO_AUTOEXEC_PAGE   0x0007
#define                                             DO_AUTOEXEC_ADDR   0x53b8
#define                                             END_UPDATE_XADDR   0x074b43
#define                                              END_UPDATE_PAGE   0x0007
#define                                              END_UPDATE_ADDR   0x4b43
#define                                                     FI_XADDR   0x07003d
#define                                                      FI_PAGE   0x0007
#define                                                      FI_ADDR   0x003d
#define                                      FILE_ABORT_ACTION_XADDR   0x075073
#define                                       FILE_ABORT_ACTION_PAGE   0x0007
#define                                       FILE_ABORT_ACTION_ADDR   0x5073
#define                                           FILE_ASK_KEY_XADDR   0x074f53
#define                                            FILE_ASK_KEY_PAGE   0x0007
#define                                            FILE_ASK_KEY_ADDR   0x4f53
#define                                           FILE_CAPTURE_XADDR   0x074acd
#define                                            FILE_CAPTURE_PAGE   0x0007
#define                                            FILE_CAPTURE_ADDR   0x4acd
#define                                             FILE_CLOSE_XADDR   0x073837
#define                                              FILE_CLOSE_PAGE   0x0007
#define                                              FILE_CLOSE_ADDR   0x3837
#define                                          FILE_CONTENTS_XADDR   0x071125
#define                                           FILE_CONTENTS_PAGE   0x0007
#define                                           FILE_CONTENTS_ADDR   0x1125
#define                                              FILE_COPY_XADDR   0x07429d
#define                                               FILE_COPY_PAGE   0x0007
#define                                               FILE_COPY_ADDR   0x429d
#define                                              FILE_EMIT_XADDR   0x074f8d
#define                                               FILE_EMIT_PAGE   0x0007
#define                                               FILE_EMIT_ADDR   0x4f8d
#define                                               FILE_EOF_XADDR   0x071261
#define                                                FILE_EOF_PAGE   0x0007
#define                                                FILE_EOF_ADDR   0x1261
#define                                             FILE_ERROR_XADDR   0x071257
#define                                              FILE_ERROR_PAGE   0x0007
#define                                              FILE_ERROR_ADDR   0x1257
#define                                             FILE_FLUSH_XADDR   0x073547
#define                                              FILE_FLUSH_PAGE   0x0007
#define                                              FILE_FLUSH_ADDR   0x3547
#define                                              FILE_GETC_XADDR   0x0748da
#define                                               FILE_GETC_PAGE   0x0007
#define                                               FILE_GETC_ADDR   0x48da
#define                                              FILE_GETS_XADDR   0x07492d
#define                                               FILE_GETS_PAGE   0x0007
#define                                               FILE_GETS_ADDR   0x492d
#define                                       FILE_INTERPRETER_XADDR   0x074efd
#define                                        FILE_INTERPRETER_PAGE   0x0007
#define                                        FILE_INTERPRETER_ADDR   0x4efd
#define                                               FILE_KEY_XADDR   0x074f31
#define                                                FILE_KEY_PAGE   0x0007
#define                                                FILE_KEY_ADDR   0x4f31
#define                                              FILE_OPEN_XADDR   0x073876
#define                                               FILE_OPEN_PAGE   0x0007
#define                                               FILE_OPEN_ADDR   0x3876
#define                                              FILE_PUTC_XADDR   0x074905
#define                                               FILE_PUTC_PAGE   0x0007
#define                                               FILE_PUTC_ADDR   0x4905
#define                                              FILE_PUTS_XADDR   0x0749c4
#define                                               FILE_PUTS_PAGE   0x0007
#define                                               FILE_PUTS_ADDR   0x49c4
#define                                          FILE_PUT_CRLF_XADDR   0x074aaa
#define                                           FILE_PUT_CRLF_PAGE   0x0007
#define                                           FILE_PUT_CRLF_ADDR   0x4aaa
#define                                              FILE_READ_XADDR   0x073d33
#define                                               FILE_READ_PAGE   0x0007
#define                                               FILE_READ_ADDR   0x3d33
#define                                            FILE_REMOVE_XADDR   0x074150
#define                                             FILE_REMOVE_PAGE   0x0007
#define                                             FILE_REMOVE_ADDR   0x4150
#define                                            FILE_RENAME_XADDR   0x0741f1
#define                                             FILE_RENAME_PAGE   0x0007
#define                                             FILE_RENAME_ADDR   0x41f1
#define                                            FILE_REWIND_XADDR   0x073726
#define                                             FILE_REWIND_PAGE   0x0007
#define                                             FILE_REWIND_ADDR   0x3726
#define                                              FILE_SEEK_XADDR   0x073655
#define                                               FILE_SEEK_PAGE   0x0007
#define                                               FILE_SEEK_ADDR   0x3655
#define                                           FILE_SET_POS_XADDR   0x07371f
#define                                            FILE_SET_POS_PAGE   0x0007
#define                                            FILE_SET_POS_ADDR   0x371f
#define                                              FILE_SIZE_XADDR   0x0711d5
#define                                               FILE_SIZE_PAGE   0x0007
#define                                               FILE_SIZE_ADDR   0x11d5
#define                                          FILE_TELL_POS_XADDR   0x073736
#define                                           FILE_TELL_POS_PAGE   0x0007
#define                                           FILE_TELL_POS_ADDR   0x3736
#define                                              FILE_TIME_XADDR   0x072749
#define                                               FILE_TIME_PAGE   0x0007
#define                                               FILE_TIME_ADDR   0x2749
#define                                         FILE_TO_MEMORY_XADDR   0x0744e1
#define                                          FILE_TO_MEMORY_PAGE   0x0007
#define                                          FILE_TO_MEMORY_ADDR   0x44e1
#define                                           FILE_TO_PAGE_XADDR   0x074645
#define                                            FILE_TO_PAGE_PAGE   0x0007
#define                                            FILE_TO_PAGE_ADDR   0x4645
#define                                              FILE_TYPE_XADDR   0x0743eb
#define                                               FILE_TYPE_PAGE   0x0007
#define                                               FILE_TYPE_ADDR   0x43eb
#define                                            FILE_UNGETC_XADDR   0x074a2c
#define                                             FILE_UNGETC_PAGE   0x0007
#define                                             FILE_UNGETC_ADDR   0x4a2c
#define                                             FILE_WRITE_XADDR   0x073a0e
#define                                              FILE_WRITE_PAGE   0x0007
#define                                              FILE_WRITE_ADDR   0x3a0e
#define                                         HIDDEN_SECTORS_XADDR   0x07036e
#define                                          HIDDEN_SECTORS_PAGE   0x0007
#define                                          HIDDEN_SECTORS_ADDR   0x036e
#define                                         INIT_FILE_HEAP_XADDR   0x070f00
#define                                          INIT_FILE_HEAP_PAGE   0x0007
#define                                          INIT_FILE_HEAP_ADDR   0x0f00
#define                                           INIT_FILE_IO_XADDR   0x075327
#define                                            INIT_FILE_IO_PAGE   0x0007
#define                                            INIT_FILE_IO_ADDR   0x5327
#define                                       INIT_FILE_SYSTEM_XADDR   0x0753a5
#define                                        INIT_FILE_SYSTEM_PAGE   0x0007
#define                                        INIT_FILE_SYSTEM_ADDR   0x53a5
#define                                          MAX_FILE_SIZE_XADDR   0x07112f
#define                                           MAX_FILE_SIZE_PAGE   0x0007
#define                                           MAX_FILE_SIZE_ADDR   0x112f
#define                                 NUMSECTORS_TRANSFERRED_XADDR   0x070378
#define                                  NUMSECTORS_TRANSFERRED_PAGE   0x0007
#define                                  NUMSECTORS_TRANSFERRED_ADDR   0x0378
#define                                           PAGE_TO_FILE_XADDR   0x0747aa
#define                                            PAGE_TO_FILE_PAGE   0x0007
#define                                            PAGE_TO_FILE_ADDR   0x47aa
#define                                            PCC_PRESENT_XADDR   0x070259
#define                                             PCC_PRESENT_PAGE   0x0007
#define                                             PCC_PRESENT_ADDR   0x0259
#define                                       PROCESS_AUTOEXEC_XADDR   0x0752ca
#define                                        PROCESS_AUTOEXEC_PAGE   0x0007
#define                                        PROCESS_AUTOEXEC_ADDR   0x52ca
#define                                           PROCESS_FILE_XADDR   0x0752bd
#define                                            PROCESS_FILE_PAGE   0x0007
#define                                            PROCESS_FILE_ADDR   0x52bd
#define                                     PUT_DEFAULT_SERIAL_XADDR   0x074faf
#define                                      PUT_DEFAULT_SERIAL_PAGE   0x0007
#define                                      PUT_DEFAULT_SERIAL_ADDR   0x4faf
#define                                         READ_CF_MODULE_XADDR   0x070036
#define                                          READ_CF_MODULE_PAGE   0x0007
#define                                          READ_CF_MODULE_ADDR   0x0036
#define                                               REDIRECT_XADDR   0x0750b9
#define                                                REDIRECT_PAGE   0x0007
#define                                                REDIRECT_ADDR   0x50b9
#define                                     REPORT_FILE_ERRORS_XADDR   0x071490
#define                                      REPORT_FILE_ERRORS_PAGE   0x0007
#define                                      REPORT_FILE_ERRORS_ADDR   0x1490
#define                                REPORT_FILE_OPEN_ERRORS_XADDR   0x0712be
#define                                 REPORT_FILE_OPEN_ERRORS_PAGE   0x0007
#define                                 REPORT_FILE_OPEN_ERRORS_ADDR   0x12be
#define                                          SET_CF_MODULE_XADDR   0x07002f
#define                                           SET_CF_MODULE_PAGE   0x0007
#define                                           SET_CF_MODULE_ADDR   0x002f
#define                                           SET_FILESIZE_XADDR   0x073020
#define                                            SET_FILESIZE_PAGE   0x0007
#define                                            SET_FILESIZE_ADDR   0x3020
#define                                           VOLUME_LABEL_XADDR   0x0711e2
#define                                            VOLUME_LABEL_PAGE   0x0007
#define                                            VOLUME_LABEL_ADDR   0x11e2

// Beginning C Header file for package: PCCard_MIB_Driver

extern _forth  void  Set_CF_Module( int module );

extern _forth  int  Read_CF_Module( void );

extern _forth    xaddr FI( void );

extern _forth  int PCC_Present( void );
#define SECTOR_SIZE 512
#define FAIL_ID_DRIVE  0x100
#define FAIL_BUSY      0x80
#define FAIL_READY     0x40
#define FAIL_DATAREQ   0x20
#define FAIL_EXT_ERR   0x10
#define FAIL_CMD       0x08
#define FAIL_ADDR      0x04
#define FAIL_NO_CARD   0x02
#define FAIL_ARGS      0x01


extern _forth  int ATA_Fail ( void );

extern _forth  int Hidden_Sectors ( void );

extern _forth  int NumSectors_Transferred ( void );

extern _forth  ulong Card_Size ( void );

extern _forth  int ATA_Command( xaddr buffer, ulong startsector, uint numsectors,         int cmd, int transfer_type, int features );

extern _forth  int ATA_Write( xaddr buffer, ulong startsector, uint numsectors );

extern _forth  int ATA_Read( xaddr buffer, ulong startsector, uint numsectors );

extern _forth  int ATA_ID_Drive( xaddr buffer );

extern _forth  int ATA_Set_Features( int config_contents, int features );

// Result Failure Flags (may be OR'd together)
#define  ERR_ATA_READ                0x01
#define  ERR_ATA_WRITE               0x02
#define  ERR_NOT_DOSFAT_DRIVE        0x04
#define  ERR_INVALID_SECTOR_NUMBER   0x08
#define  ERR_CANNOT_ADD_CLUSTER      0x10
#define  ERR_NEGATIVE_FILE_POSN      0x20
#define  ERR_WRITE_ACCESS_VIOLATION  0x40
#define  ERR_READ_ACCESS_VIOLATION   0x80
#define  ERR_FAIL_ID_DRIVE           0x100

// the following are saved in +file_open_error; set in file_open, check_fileid
#define  ERR_CANNOT_TRUNCATE_FILE    0x200
#define  ERR_FILE_DOES_NOT_EXIST     0x400
#define  ERR_ROOT_DIR_FULL           0x800
#define  ERR_DISK_IS_FULL            0x1000
#define  ERR_TOO_MANY_FILES_OPEN     0x2000
#define  ERR_BAD_OR_UNOPEN_FILEID    0x4000
// final standard error flag, saved in ata_file struct:
#define  ERR_EOF                     0x8000

// file pointer modes for file_seek and its callers:
#define  FROM_START                  1
#define  FROM_END                    2
#define  FROM_CURRENT                3

#define  FILE_MUST_EXIST       0x01  // r and r+ modes: file must exist before open
#define  OLD_FILE_TRUNCATED    0x02  // w and w+ modes: truncate to 0 upon open
#define  READABLE_STREAM       0x04  // r, r+, w+, a+ modes
#define  WRITEABLE_STREAM      0x08  // w, a, r+, w+, a+ modes
#define  WRITEABLE_AT_END_ONLY 0x10  // a, a+ modes; writes start at prior eof.


#define  R_MODE     (FILE_MUST_EXIST | READABLE_STREAM)
#define  W_MODE     (OLD_FILE_TRUNCATED | WRITEABLE_STREAM)
#define  A_MODE     (WRITEABLE_STREAM | WRITEABLE_AT_END_ONLY)
#define  RPLUS_MODE (FILE_MUST_EXIST | READABLE_STREAM | WRITEABLE_STREAM)
#define  WPLUS_MODE (OLD_FILE_TRUNCATED | READABLE_STREAM | WRITEABLE_STREAM)
#define  APLUS_MODE (READABLE_STREAM | WRITEABLE_STREAM | WRITEABLE_AT_END_ONLY)


#define NO_ECHO_FILEID  -2
// passed as output_fileid to process_file to revector emit as drop.

extern _forth  int Init_File_Heap( uint maxopen_files, uint file_bufsize,           xaddr heap_start, xaddr xheap_end );

extern _forth  ulong File_Contents( int file_position, int file_id );

extern _forth  ulong Max_File_Size( void );

extern _forth  ulong File_Size( int file_id );

extern _forth  uint Volume_Label( char* string_addr, uint string_page );

extern _forth  void Clear_File_Error( int file_id );

extern _forth  int File_Error( int file_id );

extern _forth  int File_EOF( int file_id );

extern _forth  uint Report_File_Open_Errors( char* stringaddr, uint stringpage, uint maxbytes );

extern _forth  uint Report_File_Errors( int fileid, char* stringaddr, uint stringpage,            uint maxbytes );

extern _forth  xaddr File_Time( int file_id );

extern _forth  void Dir( void );

extern _forth  void Dir_Names( void );

extern _forth  void Dir_Open( void );

extern _forth  int Set_Filesize( ulong size, int file_id );

extern _forth  int File_Flush( int file_id );

extern _forth  int File_Seek( int file_id, long offset, int mode );

extern _forth  int File_Set_Pos( int file_id, long offset );

extern _forth  int File_Rewind( int file_id );

extern _forth  long File_Tell_Pos( int file_id );

extern _forth  int File_Close( int file_id );

extern _forth  int File_Open( char* name_addr, uint name_page, int name_count, int access_mode );

extern _forth  long File_Write( void* source_addr, uint source_page, ulong numbytes, int file_id );

extern _forth  long File_Read( void* dest_addr, uint dest_page, ulong numbytes, int file_id );

extern _forth  int File_Remove( char* name_addr, uint name_page, int name_count );

extern _forth  int File_Rename( char* prior_string_addr, uint prior_string_page, int prior_count, char* new_string_addr, uint new_string_page, int new_count );

extern _forth  int File_Copy( char* prior_string_addr, uint prior_string_page,     int prior_string_count,     char* new_string_addr, uint new_string_page, int new_string_count );

extern _forth  void File_Type( char* name_addr, uint name_page, int name_count );

extern _forth  long File_To_Memory( void* dest_addr, uint dest_page, ulong numbytes, int file_id );

extern _forth  void File_To_Page( uint dest_page );

extern _forth  void Page_To_File( uint source_page );

extern _forth  int File_Getc( int file_id );

extern _forth  int File_Putc( char c, int file_id );

extern _forth  int File_Gets( char* string_addr, uint string_page, uint bufsize, int file_id );

extern _forth  int File_Puts( char* source_addr, uint source_page, uint maxchars, int file_id );

extern _forth  int File_Ungetc( char c, int file_id );

extern _forth  int File_Put_CRLF( int file_id );

extern _forth  int File_Capture( int fileid );

extern _forth  void End_Update( void );

extern _forth  void File_Interpreter( void );

extern _forth  uchar File_Key( void );

extern _forth  int File_Ask_Key( void );

extern _forth  void File_Emit( char c );

extern _forth  void Put_Default_Serial( void );

extern _forth  void File_Abort_Action( void );

extern _forth  void Redirect( int input_file_id, int output_file_id, void(*fn)(), uint fn_page);

extern _forth  void Process_File( int input_file_id, int output_file_id );

extern _forth  int Process_Autoexec( int autoexec_echo );

extern _forth  int Init_File_IO( uint max_open_files, uint file_bufsize,         xaddr heap_start, xaddr heap_end, xaddr xfat_info );

extern _forth  int Init_File_System( void );

extern _forth  void Do_Autoexec( void );

// End of C Header file for package: PCCard_MIB_Driver

// Beginning C Header file for package: To_xFlash

extern _forth  int To_xFlash ( xaddr source, xaddr destination, uint numbytes );

extern _forth  int Query_xMemory ( int page );
#ifndef boolean
typedef int     boolean;
#endif

extern _forth  boolean Is_xRAM ( int page );

extern _forth  boolean Is_xFlash ( int page );

extern _forth  void Page_To_xFLASH ( int source_page );

extern _forth  void Download_Map_QVGA ( void );

extern _forth  void Download_Map_WCB ( void );

extern _forth  void Standard_Map_QVGA ( void );

extern _forth  void Standard_Map_WCB ( void );

// End of C Header file for package: To_xFlash

// This #endif statement closes the block begun at
// the front of the pre
#endif

// *** Note: be sure to #include this file before library.c, and in any other
// source files that use these kernel extension functions.
